package com.inca.npbusi.sales.bms_sa_doc;

import com.inca.entity.base.Goods;
import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.Hovcallback;
import com.inca.np.gui.control.UserManager;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.gui.ste.CSteModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.DefaultNPParam;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.saHelper.SaExamHelper;
import com.inca.npx.ste.ApIF;
import com.inca.pirce.tools.ExamPriceUtil;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.sastqtyhov.Sadynstqty_hov;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import org.apache.log4j.Category;

public class Bms_sales_detail extends CDetailModel implements Hovcallback {
   private Category a = Category.getInstance(Bms_sales_detail.class);
   private String b = "";
   private Sadynstqty_hov c;
   private String d;
   private HashMap<String, String> e;
   private HashMap<String, ArrayList<String>> f;

   public Bms_sales_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售发货单细单", var2);
      new HashMap();
      this.c = null;
      this.d = "";
      this.e = new HashMap();
      this.f = new HashMap();
      if (!DefaultNPParam.runonserver || DefaultNPParam.debug != 0) {
         this.c = new Sadynstqty_hov((ApIF)var2);
      }

   }

   public String getTablename() {
      return "bms_sa_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_beforeNew() {
      if (this.mdemodel.getMasterModel().getRow() >= 0 && this.mdemodel.getMasterModel().getRow() != this.mdemodel.getMasterModel().getRowCount()) {
         return "2".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus")) && "0".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "approveflag")) ? super.on_beforeNew() : -1;
      } else {
         return -1;
      }
   }

   protected int on_checkrow11(int var1, DBTableModel var2) {
      String var8;
      if ((var8 = this.getItemValue(var1, "discount")) != null && !var8.equals("") && !var8.equals("0") && !var8.equals("0.00")) {
         if (DecimalHelper.toDec(var8).compareTo(new BigDecimal("0")) < 0) {
            this.infoMessage("提示", "折扣不能小于零");
            return -1;
         } else {
            var8 = this.getItemValue(var1, "goodsqty");
            if (!"".equals(var8) && DecimalHelper.toDec(var8).compareTo(new BigDecimal("0")) > 0) {
               String var3 = this.getItemValue(var1, "unitprice");
               if (!"".equals(var3) && DecimalHelper.toDec(var3).compareTo(new BigDecimal("0")) >= 0) {
                  if ((var3 = this.getItemValue(var1, "posid")) != null && !var3.equals("") && !var3.equals("0")) {
                     DBTableModel var4 = null;
                     RemotesqlHelper var5 = new RemotesqlHelper();
                     var3 = "select * from bms_storer_pos where posid = " + var3;

                     try {
                        var4 = var5.doSelect(var3, 0, 1);
                     } catch (Exception var6) {
                        var6.printStackTrace();
                     }

                     if (var4.getRowCount() <= 0) {
                        return -1;
                     }

                     var3 = var4.getItemValue(0, "goodsunitflag");
                     if ("1".equals(var3)) {
                        String var7 = this.getItemValue(var1, "packsize");
                        if (DecimalHelper.toDec(var8).remainder(DecimalHelper.toDec(var7)).compareTo(new BigDecimal("0")) != 0) {
                           this.infoMessage("提示", "整件货位的数量必须是整件！");
                           return -1;
                        }
                     }
                  }

                  return 0;
               } else {
                  this.infoMessage("提示", "要求单价必须大于等于零");
                  return -1;
               }
            } else {
               this.infoMessage("提示", "使用单位数量必须大于零");
               return -1;
            }
         }
      } else {
         this.infoMessage("提示", "折扣不能为空，必须输入0到1之间的数");
         return -1;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4 = ((Bms_sales_mde)this.mdemodel).getEntryid();
      String var5;
      String var6;
      String var7;
      String var8;
      String var9;
      String[] var11;
      String var12;
      DBTableModel var28;
      String var31;
      String var35;
      if (var2.equals("goodsid")) {
         this.commitEdit();
         super.on_itemvaluechange(var1, var2, var3);
         System.out.println(var1);
         var5 = this.getItemValue(var1, "goodsunit");
         this.setItemValue(var1, "goodsuseunit", var5);
         if (this.b(var1)) {
            var6 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            var7 = this.getItemValue(var1, "goodsid");
            var8 = this.getItemValue(var1, "batchid");
            DBTableModel var33 = null;
            ClientRequest var39 = new ClientRequest();
            StringCommand var40 = new StringCommand("销售发货单根据取价逻辑自动提取价格信息");
            ParamCommand var38;
            (var38 = new ParamCommand()).addParam("customid", var6);
            var38.addParam("goodsid", var7);
            var38.addParam("batchid", var8);
            var38.addParam("isgroupsales", "0");
            var38.addParam("entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
            var39.addCommand(var40);
            var39.addCommand(var38);
            ServerResponse var29 = null;

            try {
               var29 = SendHelper.sendRequest(var39);
            } catch (Exception var18) {
               var18.printStackTrace();
            }

            if (((StringCommand)var29.commandAt(0)).getString().startsWith("+OK")) {
               if (var29.commandAt(1) instanceof DataCommand) {
                  var33 = ((DataCommand)var29.commandAt(1)).getDbmodel();
               } else if (var29.commandAt(1) instanceof StringCommand) {
                  var29.commandAt(1);
               }
            }

            if (var33 != null && var33.getRowCount() > 0) {
               var31 = var33.getItemValue(0, "price");
               var35 = var33.getItemValue(0, "priceid");
               this.setItemValue(var1, "priceid", var35);
               this.setItemValue(var1, "priceopcode", var33.getItemValue(0, "priceopcode"));
               this.setItemValue(var1, "pricename", var33.getItemValue(0, "pricename"));
               this.setItemValue(var1, "unitprice", var31);
               this.setItemValue(var1, "timepriceid", var33.getItemValue(0, "refrencepriceid"));
               this.setItemValue(var1, "timepricename", var33.getItemValue(0, "refrencepricename"));
               this.setItemValue(var1, "timeprice", var33.getItemValue(0, "refrenceprice"));
               this.setItemValue(var1, "oldunitprice", var31);
               this.setItemValue(var1, "setname", var33.getItemValue(0, "setname"));
               this.setItemValue(var1, "bidsetid", var33.getItemValue(0, "setid"));
               this.on_itemvaluechange(var1, "unitprice", var31);
               this.on_itemvaluechange(var1, "priceid", var35);
            } else if (var29.commandAt(0).toString().startsWith("-Error")) {
               this.setItemValue(var1, "priceid", "");
               this.setItemValue(var1, "priceopcode", "");
               this.setItemValue(var1, "pricename", "");
               this.setItemValue(var1, "unitprice", "");
               this.setItemValue(var1, "oldunitprice", "");
               this.infoMessage("提示", var29.commandAt(0).toString());
            } else {
               this.setItemValue(var1, "priceid", "");
               this.setItemValue(var1, "priceopcode", "");
               this.setItemValue(var1, "pricename", "");
               this.setItemValue(var1, "unitprice", "");
               this.setItemValue(var1, "oldunitprice", "");
               this.infoMessage("提示", "没有取到价格，请先定义价格!");
            }

            var6 = this.getItemValue(var1, "goodsid");
            var7 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            ClientRequest var30 = new ClientRequest();
            StringCommand var37 = new StringCommand("Bms_sales_detail.取得上次销价类型信息");
            StringCommand var43 = new StringCommand(var6);
            var40 = new StringCommand(var7);
            var30.addCommand(var37);
            var30.addCommand(var43);
            var30.addCommand(var40);
            var12 = ((Bms_sales_mde)this.mdemodel).getEntryid();
            var30.addCommand(new StringCommand(var12));

            String var14;
            label214: {
               try {
                  var29 = SendHelper.sendRequest(var30);
               } catch (Exception var23) {
                  this.a.error("error", var23);
                  this.errorMessage("错误", var23.getMessage());
                  break label214;
               }

               if (((StringCommand)var29.commandAt(0)).getString().startsWith("+OK")) {
                  var31 = ((StringCommand)var29.commandAt(1)).getString();
                  var35 = ((StringCommand)var29.commandAt(2)).getString();
                  var9 = ((StringCommand)var29.commandAt(3)).getString();
                  String var13 = ((StringCommand)var29.commandAt(4)).getString();
                  var14 = ((StringCommand)var29.commandAt(5)).getString();
                  this.setItemValue(var1, "lastpriceid", var31);
                  this.setItemValue(var1, "lastpricename", var35);
                  this.setItemValue(var1, "lastunitprice", var9);
                  this.setItemValue(var1, "lastdate", var13);
                  this.setItemValue(var1, "lastgoodsqty", var14);
               }
            }

            int var34 = var1;
            Bms_sales_detail var24 = this;
            var7 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
            var8 = this.getItemValue(var1, "priceid");
            var9 = "select rate from bms_sa_add_some_rate r,bms_rate_goods_relations e where r.rateid = e.rateid  and r.entryid = " + var7 + " and r.pricetypeid = " + var8 + " and e.goodsid = " + var3;
            RemotesqlHelper var46 = new RemotesqlHelper();

            label286: {
               try {
                  DBTableModel var47;
                  if ((var47 = var46.doSelect(var9, 0, 1)).getRowCount() != 0) {
                     var24.setItemValue(var34, "discount", var47.getItemValue(0, "rate"));
                     var24.setItemValue(var34, "olddiscount", var47.getItemValue(0, "rate"));
                     break label286;
                  }

                  var24.setItemValue(var34, "discount", "1");
               } catch (Exception var22) {
                  var22.printStackTrace();
               }

               ClientRequest var41 = new ClientRequest();
               var7 = null;
               StringCommand var32 = new StringCommand("销售发货单管理:获取销售折扣");
               ParamCommand var48 = new ParamCommand();
               var11 = null;
               var9 = null;
               int var42 = this.mdemodel.getMasterModel().getRow();
               var14 = this.mdemodel.getMasterModel().getItemValue(var42, "customid");
               var7 = ((Bms_sales_mde)this.mdemodel).getEntryid();
               var48.addParam("goodsid", var3);
               var48.addParam("customid", var14);
               var48.addParam("entryid", var7);
               var41.addCommand(var32);
               var41.addCommand(var48);

               try {
                  if (((StringCommand)(var29 = SendHelper.sendRequest(var41)).commandAt(0)).getString().startsWith("+OK")) {
                     ParamCommand var44 = (ParamCommand)var29.commandAt(1);
                     var24.setItemValue(var34, "discount", var44.getValue("discount"));
                     var24.setItemValue(var34, "olddiscount", var44.getValue("discount"));
                  }
               } catch (Exception var17) {
                  var17.printStackTrace();
               }
            }

            var6 = "";
            var28 = null;
            var8 = "select sataxrate salestaxrate from pub_entry_goods_v where goodsid =" + var3 + " and entryid=" + var4;
            RemotesqlHelper var45 = new RemotesqlHelper();

            try {
               var28 = var45.doSelect(var8, 0, 1);
            } catch (Exception var16) {
               var16.printStackTrace();
            }

            if (var28 != null && var28.getRowCount() > 0) {
               var6 = var28.getItemValue(0, "salestaxrate");
            }

            this.setItemValue(var1, "taxrate", var6);
            this.on_itemvaluechange(var1, "goodsuseqty", this.getItemValue(var1, "goodsuseqty"));
            if ((var31 = ((Bms_sales_mde)this.mdemodel).nosapriceinfo) != null && var31.equals("1") && !this.b(var3)) {
               this.infoMessage("友情提示", "ID为" + var3 + "的货品尚未定义零售价，请及时维护!~");
            }
         }

         this.setItemValue(var1, "oldunitprice", this.getItemValue(var1, "unitprice"));
         this.on_itemvaluechange(var1, "oldunitprice", this.getItemValue(var1, "unitprice"));

         try {
            var6 = this.getItemValue(var1, "unitprice");
            var7 = this.getItemValue(var1, "goodsqty");
            var8 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
            var9 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "salesdeptid");
            var31 = this.getItemValue(var1, "goodsid");
            var5 = ExamPriceUtil.getExamPrice(ExamPriceUtil.BMS, var8, var9, var31);
            var6 = ExamPriceUtil.getExamProfit(var7, var6, var5);
            this.setItemValue(var1, "examprice", var5);
            this.setItemValue(var1, "examprofit", var6);
         } catch (Exception var15) {
            this.errorMessage("错误", "获取考核价失败！");
            var15.printStackTrace();
         }
      } else {
         String[] var10;
         if (var2.equals("oldunitprice")) {
            this.setItemValue(var1, "discount", this.getItemValue(var1, "olddiscount"));
            var5 = this.getItemValue(var1, "discount");
            var6 = DecimalHelper.multi(var3, var5, 10);
            this.setItemValue(var1, "unitprice", var6);
            var7 = this.getItemValue(var1, "goodsqty");
            var8 = this.getItemValue(var1, "goodsid");
            var9 = this.getItemValue(var1, "examprice");
            var10 = SaExamHelper.genExamInfo(var8, var6, var7, false, var1, var9, var4);
            this.setItemValue(var1, "examprice", var10[0]);
            this.setItemValue(var1, "examprofit", var10[1]);
            this.a(var1);
            var5 = this.getItemValue(var1, "batchid");
            if (var7 == null || var7.length() == 0) {
               var7 = "0";
            }

            var6 = this.getItemValue(var1, "total_line");
            if (var5 != null && !var5.equals("")) {
               var11 = getLotGross(var8, var5, var3, var7, var6);
               this.setItemValue(var1, "lotgross", var11[0]);
               this.setItemValue(var1, "lotgrossrate", var11[1]);
            }
         } else if (var2.equals("unitprice")) {
            var6 = this.getItemValue(var1, "goodsid");
            this.a(var1);
            if ((var7 = this.getItemValue(var1, "oldunitprice")).equals("") || var7 == null) {
               var7 = var3;
            }

            if (DecimalHelper.toDec(var7).compareTo(DecimalHelper.toDec("0")) != 0) {
               var8 = DecimalHelper.divide(var3, var7, 4);
               this.setItemValue(var1, "discount", var8);
            }

            var8 = this.getItemValue(var1, "batchid");
            if ((var9 = this.getItemValue(var1, "goodsqty")) == null || var9.length() == 0) {
               var9 = "0";
            }

            var31 = this.getItemValue(var1, "total_line");
            if (var8 != null && !var8.equals("")) {
               String[] var26 = getLotGross(var6, var8, var3, var9, var31);
               this.setItemValue(var1, "lotgross", var26[0]);
               this.setItemValue(var1, "lotgrossrate", var26[1]);
            }

            try {
               var5 = this.getItemValue(var1, "unitprice");
               var6 = this.getItemValue(var1, "goodsqty");
               var35 = UserManager.getCurrentUser().getEntryid();
               var31 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "salesdeptid");
               var12 = this.getItemValue(var1, "goodsid");
               var31 = ExamPriceUtil.getExamPrice(ExamPriceUtil.BMS, var35, var31, var12);
               var6 = ExamPriceUtil.getExamProfit(var6, var5, var31);
               this.setItemValue(var1, "examprice", var31);
               this.setItemValue(var1, "examprofit", var6);
            } catch (Exception var21) {
               this.errorMessage("错误", "获取考核价失败！");
               var21.printStackTrace();
            }
         } else if ("goodsuseqty".equals(var2) && !"".equals(var3)) {
            if ((var5 = this.getItemValue(var1, "goodsuseunit")).indexOf("(") == -1) {
               var6 = "1";
            } else {
               var6 = var5.substring(var5.indexOf("(") + 1, var5.indexOf(")"));
            }

            var7 = DecimalHelper.multi(var3, var6, 6);
            var8 = this.getItemValue(var1, "goodsid");
            var9 = this.getItemValue(var1, "goodsname");
            int var36 = this.mdemodel.getMasterModel().getRow();
            var5 = this.mdemodel.getMasterModel().getItemValue(var36, "customid");
            var6 = this.getItemValue(var1, "salesdtlid");
            var35 = "0";
            if (var6 != null && var6.trim().length() > 0) {
               var35 = a(var6);
            }

            var12 = this.getItemValue(var1, "limitedsaleflag");
            var10 = null;

            try {
               if ("1".equals(var12) && DecimalHelper.toDec(var7).compareTo(DecimalHelper.toDec(var35)) > 0) {
                  var6 = DecimalHelper.sub(var7, var35, 6);
                  if (DecimalHelper.toDec(var31 = NpbusiDBHelper.getAllotqtyinfo(var8, var5).getItemValue(0, "allotqty")).compareTo(DecimalHelper.toDec(var6)) < 0) {
                     this.infoMessage("提示", "货品" + var9 + "为配额销售货品，当前可用配额为" + var31 + "，\n销售数量不得大于可用配额，请检查!");
                     return;
                  }
               }
            } catch (Exception var20) {
               var20.printStackTrace();
               this.infoMessage("提示", "查询货品配额销售信息时出错:" + var20.getMessage());
            }

            if ((var6 = this.getItemValue(var1, "leastsaleqty")) != null && var6.trim().length() > 0 && !"0".equals(var6) && DecimalHelper.toDec(var7).remainder(DecimalHelper.toDec(var6)).compareTo(new BigDecimal("0")) != 0) {
               var5 = DecimalHelper.divide(var7, var6, 0);
               if ("0".equals(var5)) {
                  var5 = "1";
               }

               this.infoMessage("提示", "根据公司管理规定，您输入的数量【" + var7 + "】不是该货品最小销售数量【" + var6 + "】的整数倍，您可以录入【" + DecimalHelper.multi(var6, var5, 6) + "】或者【" + DecimalHelper.multi(var6, DecimalHelper.add(var5, "1", 6), 6) + "】进行销售。");
            }

            this.setItemValue(var1, "goodsqty", var7);
            if (!(var5 = this.getItemValue(var1, "packsize")).equals("") && var5 != null) {
               this.setItemValue(var1, "packqty", DecimalHelper.divide(var7, var5, 6));
            } else {
               this.setItemValue(var1, "packqty", "0");
            }

            var5 = this.getItemValue(var1, "batchid");
            if ((var6 = this.getItemValue(var1, "unitprice")) == null || var6.length() == 0) {
               var6 = "0";
            }

            this.a(var1);
            var9 = this.getItemValue(var1, "examprice");
            String[] var25 = SaExamHelper.genExamInfo(var8, var6, var7, false, var1, var9, var4);
            this.setItemValue(var1, "examprice", var25[0]);
            this.setItemValue(var1, "examprofit", var25[1]);
            var4 = this.getItemValue(var1, "total_line");
            if (var5 != null && !var5.equals("")) {
               var25 = getLotGross(var8, var5, var6, var7, var4);
               this.setItemValue(var1, "lotgross", var25[0]);
               this.setItemValue(var1, "lotgrossrate", var25[1]);
            }
         } else if ("goodsuseunit".equals(var2) && !"".equals(var3)) {
            var5 = this.getItemValue(var1, "goodsuseqty");
            if (var3.indexOf("(") == -1) {
               var6 = "1";
            } else {
               var6 = var3.substring(var3.indexOf("(") + 1, var3.indexOf(")"));
            }

            this.setItemValue(var1, "usepacksize", var6);
            var7 = DecimalHelper.multi(var5, var6, 6);
            this.setItemValue(var1, "goodsqty", var7);
            if (!(var8 = this.getItemValue(var1, "packsize")).equals("") && var8 != null) {
               this.setItemValue(var1, "packqty", DecimalHelper.divide(var7, var8, 6));
            } else {
               this.setItemValue(var1, "packqty", "0");
            }

            var9 = this.getItemValue(var1, "batchid");
            var31 = this.getItemValue(var1, "goodsid");
            if ((var5 = this.getItemValue(var1, "unitprice")) == null || var5.length() == 0) {
               var5 = "0";
            }

            this.setFocus("goodsuseqty");
            this.a(var1);
            var6 = this.getItemValue(var1, "total_line");
            if (var9 != null && !var9.equals("")) {
               var11 = getLotGross(var31, var9, var5, var7, var6);
               this.setItemValue(var1, "lotgross", var11[0]);
               this.setItemValue(var1, "lotgrossrate", var11[1]);
            }

            var35 = this.getItemValue(var1, "examprice");
            var10 = SaExamHelper.genExamInfo(var31, var5, var7, false, var1, var35, var4);
            this.setItemValue(var1, "examprice", var10[0]);
            this.setItemValue(var1, "examprofit", var10[1]);
         } else if ("discount".equals(var2) && !"".equals(var3)) {
            var5 = this.getItemValue(var1, "oldunitprice");
            var6 = DecimalHelper.multi(var3, var5, 10);
            this.setItemValue(var1, "unitprice", var6);
            this.on_itemvaluechange(var1, "unitprice", var6);
         } else if ("priceid".equals(var2) && !"".equals(var3)) {
            var5 = "select modifyflag from pub_price_type where priceid = " + var3;
            RemotesqlHelper var27 = new RemotesqlHelper();

            try {
               if ((var28 = var27.doSelect(var5, 0, 1)) != null && var28.getRowCount() > 0) {
                  var8 = var28.getItemValue(0, "modifyflag");
                  if ("0".equals(var8)) {
                     this.getDBColumnDisplayInfo("unitprice").setReadonly(true);
                  } else {
                     this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
                  }
               }
            } catch (Exception var19) {
               var19.printStackTrace();
            }
         }

         super.on_itemvaluechange(var1, var2, var3);
      }
   }

   private static String a(String var0) {
      var0 = "select goodsqty from bms_sa_dtl where salesdtlid=" + var0;
      RemotesqlHelper var1 = new RemotesqlHelper();

      try {
         DBTableModel var3;
         if ((var3 = var1.doSelect(var0, 0, 1)) != null && var3.getRowCount() > 0) {
            return var3.getItemValue(0, "goodsqty");
         }
      } catch (Exception var2) {
         var2.printStackTrace();
      }

      return "0";
   }

   private boolean b(String var1) {
      ClientRequest var2 = new ClientRequest();
      StringCommand var3 = new StringCommand("销售订单管理.检查没有是否有零售价");
      ParamCommand var4;
      (var4 = new ParamCommand()).addParam("goodsid", var1);
      var4.addParam("entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
      var2.addCommand(var3);
      var2.addCommand(var4);
      ServerResponse var6 = null;
      boolean var7 = true;

      try {
         var6 = SendHelper.sendRequest(var2);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if (((StringCommand)var6.commandAt(0)).getString().startsWith("+OK") && (var1 = ((StringCommand)var6.commandAt(1)).getString()) != null) {
         if (var1.equals("0")) {
            var7 = false;
         } else if (var1.equals("1")) {
            var7 = true;
         }
      }

      return var7;
   }

   public static String[] getLotGross(String var0, String var1, String var2, String var3, String var4) {
      if (var1 != null && !var1.equals("") && var0 != null && !var0.equals("")) {
         RemotesqlHelper var5 = new RemotesqlHelper();
         String var6 = null;
         var6 = null;
         String var7 = null;
         var6 = null;
         String[] var8 = new String[2];
         if (var1 != null && var1.length() > 0) {
            if ("0".equals(var1)) {
               var7 = var2;
            } else {
               var6 = "select nvl(unitprice,0) unitprice from bms_batch_def where goodsid=" + var0 + " and batchid=" + var1;

               try {
                  var7 = var5.doSelect(var6, 0, 1).getItemValue(0, "unitprice");
               } catch (Exception var9) {
                  var9.printStackTrace();
               }
            }

            var6 = DecimalHelper.multi(DecimalHelper.sub(var2, var7, 10), var3, 2);
         }

         var8[0] = var6;
         if (var6.equals("") || var6 == null) {
            var6 = "0";
         }

         if (var4 != null && !"".equals(var4) && DecimalHelper.toDec(var4).compareTo(DecimalHelper.toDec("0")) != 0) {
            var0 = DecimalHelper.divide(var6, var4, 6);
            var8[1] = var0;
         } else {
            var8[1] = "0";
         }

         return var8;
      } else {
         return null;
      }
   }

   private void a(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange");
      String var3 = this.getItemValue(var1, "unitprice");
      String var4 = this.getItemValue(var1, "goodsqty");
      String var5 = this.getItemValue(var1, "taxrate");
      if (var2 != null && !var2.equals("") && DecimalHelper.comparaDecimal(var2, "0") != 0) {
         var3 = DecimalHelper.multi(var3, var2, 10);
      }

      var3 = DecimalHelper.divide(var2 = DecimalHelper.multi(var3, var4, 2), DecimalHelper.add("1", var5, 10), 2);
      this.setItemValue(var1, "total_line", var2);
      this.setItemValue(var1, "notaxmoney", var3);
   }

   private boolean b(int var1) {
      boolean var2 = false;
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      String var4 = this.getItemValue(var1, "goodsid");
      String var5 = this.getItemValue(var1, "batchid");
      if (var3 != null && !var3.equals("")) {
         ClientRequest var6 = new ClientRequest();
         StringCommand var7 = new StringCommand("禁销限销判断");
         ParamCommand var8;
         (var8 = new ParamCommand()).addParam("customid", var3);
         var8.addParam("goodsid", var4);
         var8.addParam("batchid", var5);
         var3 = ClientUserManager.getCurrentUser().getEntryid();
         var8.addParam("entryid", var3);
         var6.addCommand(var7);
         var6.addCommand(var8);
         ServerResponse var10 = null;

         try {
            var10 = SendHelper.sendRequest(var6);
         } catch (Exception var9) {
            var9.printStackTrace();
         }

         StringCommand var11 = (StringCommand)var10.commandAt(0);
         var5 = null;
         if (var11.getString().startsWith("+OK")) {
            var5 = ((StringCommand)var10.commandAt(1)).getString();
            if ("true".equals(var5)) {
               var2 = true;
            } else {
               var2 = false;
            }
         }

         if (!var2) {
            this.infoMessage("提示", "此货品禁止对本客户销售,请重新选择");
            this.setItemValue(var1, "opcode", "");
         }

         return var2;
      } else {
         this.infoMessage("提示", "请先录入客户");
         this.setItemValue(var1, "opcode", "");
         return false;
      }
   }

   public boolean isLimitCustom() {
      String var1 = ((Bms_sales_mde)this.mdemodel).getApvalue("非严格控制批次限销");
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      if (!var1.equals("1")) {
         if (this.b != null && !"".equals(this.b) && !this.b.equals(var2)) {
            this.infoMessage("提示", "该批次不能销售(批次限销),请重新选择");
            return false;
         }
      } else if (this.b != null && !"".equals(this.b) && !this.b.equals(var2)) {
         if (JOptionPane.showConfirmDialog(this.frame, "该批次为限销批次(不建议销售给该客户)，是否继续?", "提示", 0) == 0) {
            return true;
         }

         return false;
      }

      return true;
   }

   public boolean canInvokehov(String var1) {
      if (var1.equals("priceopcode")) {
         label30: {
            String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            String var3 = this.getItemValue(this.getRow(), "goodsid");
            if (var2 != null && !var2.equals("")) {
               if (var3 != null && !var3.equals("")) {
                  break label30;
               }

               this.infoMessage("提示", "请先录入货品！");
               return false;
            }

            this.infoMessage("提示", "请先录入客户！");
            return false;
         }
      }

      if (var1.equals("opcode") && this.getRow() != -1) {
         this.setdbStatus(this.getRow(), 2);
      }

      return true;
   }

   public String getHovOtherWheres(int var1, String var2) {
      if (var2.equals("priceopcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var3 = this.getItemValue(var1, "goodsid");
         if ("".equals(var3)) {
            this.infoMessage("提示", "请先选择货品");
            return "1 = 2";
         } else {
            return "(customid is null or customid = " + var2 + ") and goodsid = " + var3 + " and priceid IN(SELECT priceid FROM pub_price_type WHERE workflag IN(1)) " + "and entryid=" + ((Bms_sales_mde)this.mdemodel).getEntryid();
         }
      } else {
         return super.getHovOtherWheres(var1, var2);
      }
   }

   private String a() {
      int var1 = this.mdemodel.getMasterModel().getRow();
      String var2 = ((Bms_sales_mde)this.mdemodel).getEntryid();
      String var5 = this.mdemodel.getMasterModel().getItemValue(var1, "customid");
      CompanyOnClient var6;
      (var6 = new CompanyOnClient(var5)).setCompanyType(2);
      String var3 = GSPHelper.getGoodsOtherWheresOnHov(var2, "bms_stqty_union_v", "goodsid", true, false);

      try {
         var3 = var3 + var6.sendLimitCheck("3", var2);
         return var3;
      } catch (Exception var4) {
         this.errorMessage("获取供应商经营范围、类别时错误", var4.getMessage());
         return "";
      }
   }

   public void doNew() {
      if (this.on_beforeNew() == 0) {
         int var1 = this.getRow();
         this.invokeMultimdehov(var1, "opcode", "");
         this.setFocus("unitprice");
      }

   }

   protected void invokeMultimdehov(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("opcode")) {
         if (var3.length() > 0 && this.d.length() > 0 && var3.equalsIgnoreCase(this.d)) {
            return;
         }

         String var11 = ((Bms_sales_mde)this.mdemodel).getEntryid();
         this.c.clearCond();
         var2 = ((Bms_sales_mde)this.mdemodel).getApvalue("是否提示选择老批次");
         if ("1".equals(var2)) {
            this.c.warnOldbatch(true);
         }

         boolean var13 = false;
         boolean var4 = false;
         boolean var5 = false;
         String var6 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var7 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批号");
         String var8 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批次");
         String var9 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货位");
         String var10 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货品状态");
         if ("1".equals(var7)) {
            var13 = true;
         }

         if ("1".equals(var8)) {
            var4 = true;
         }

         if ("1".equals(var9)) {
            var5 = true;
         }

         "1".equals(var10);
         boolean var14 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存是否选择到批号、批次、货位由销售控制").equals("1");
         this.c.setGoodsdtlflag(true);
         this.c.setLotflag(var13);
         this.c.setBatchflag(var4);
         this.c.setPosflag(var5);
         this.c.setUsestatusflag(true);
         this.c.setFlagEditable(var14);
         this.c.setCustomid(var6);
         this.c.setEntryid(var11);
         this.c.setHovcallback(this);
         var11 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "stsetid");
         var2 = " exists (select storageid from bms_st_def where  bms_st_def.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =" + ((Bms_sales_mde)this.mdemodel).getEntryid();
         if (!"".equals(var11)) {
            var2 = " exists (select storageid from bms_st_set_dtl where stsetid = " + var11 + " and bms_st_set_dtl.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =" + ((Bms_sales_mde)this.mdemodel).getEntryid();
         }

         var11 = ((Bms_sales_mde)this.mdemodel).getApvalue("非严格控制批次限销");
         if (!"1".equals(var11)) {
            var2 = var2 + " and (  (nvl(limitid,0) = 0 and nvl(limitcustomsetid,0) = 0 ) or   limitid = " + var6 + "  or    limitcustomsetid in (select setid from pub_custom_set_dtl where customid = " + var6 + " ) )   and (nvl(bannedCustomerID,-1) <> " + var6 + " and  nvl(bannedcustomersetid,-1) not in" + " (select setid from pub_custom_set_dtl where customid = " + var6 + "))";
         }

         var2 = var2 + " and " + this.a();
         CSteModel var12;
         if ((var11 = (var12 = this.mdemodel.getMasterModel()).getItemValue(var12.getRow(), "storageid")) == null || var11.trim().isEmpty()) {
            var11 = "-1";
         }

         var2 = var2 + " and bms_stqty_union_v.storageid=" + var11;
         this.c.showDialog(this.getParentFrame(), "选择货品输入数量", "opcode", var3, var2);
         this.setFocus("goodsuseqty");
      }

   }

   public int hovcallback_itemvaluechanged(int var1, String var2, String var3, DBTableModel var4) {
      if ((var2.equalsIgnoreCase("editgoodsqty") || var2.equalsIgnoreCase("editpackqty")) && var3.trim().length() > 0) {
         var4.getItemValue(var1, "goodsid");
         if (!this.d(var4.getItemValue(var1, "goodsid"))) {
            return 0;
         }

         int var5 = this.mdemodel.getMasterModel().getRow();
         var2 = this.mdemodel.getMasterModel().getItemValue(var5, "customid");
         if (!"".equals(a(var2, var4, var1))) {
            this.infoMessage("提示", a(var2, var4, var1));
            return 0;
         }

         var2 = var4.getItemValue(var1, "editgoodsqty");
         this.b = var4.getItemValue(var1, "limitid");
         if (var2.length() == 0) {
            return 0;
         }

         if (!this.isLimitCustom()) {
            return 0;
         }
      }

      return 0;
   }

   public void hovcallback_ok(int var1, DBTableModel var2, CTable var3) {
      DBTableModel var9 = this.getDBtableModel();

      for(int var10 = 0; var10 < var2.getRowCount(); ++var10) {
         if (!"".equals(var2.getItemValue(var10, "editgoodsqty"))) {
            int var4 = var9.getRowCount();
            var9.appendRow();
            this.on_new(var4);
            String var5 = var2.getItemValue(var10, "goodsid");
            String var6 = ClientUserManager.getCurrentUser().getEntryid();
            String var7;
            if (var5 != null && var5.trim().length() > 0) {
               var7 = null;

               try {
                  var6 = String.format("select m.sequenceflag from pub_entry_goods m where m.goodsid=%s and m.entryid=%s", var5, var6);
                  DBTableModel var11;
                  if ((var11 = (new RemotesqlHelper()).doSelect(var6, 0, 1)) != null && var11.getRowCount() > 0) {
                     if ((var7 = var11.getItemValue(0, "sequenceflag")) != null && var7.trim().length() > 0 && "1".equals(var7)) {
                        this.setItemValue(var4, "sequenceflag", var7);
                     } else {
                        this.setItemValue(var4, "sequenceflag", "0");
                     }
                  }
               } catch (Exception var8) {
                  var8.printStackTrace();
               }
            }

            var7 = var2.getItemValue(var10, "invaliddays");
            if ((var6 = var2.getItemValue(var10, "toinvdayswarn")) != null && var6.trim().length() > 0 && var7 != null && var7.trim().length() > 0 && DecimalHelper.toDec(var7).compareTo(DecimalHelper.toDec(var6)) <= 0 && JOptionPane.showConfirmDialog(this.mdemodel.getParentFrame(), "所选货品距失效期过近，不建议销售！\n是否继续销售？", "提示", 2) != 0) {
               this.getDBtableModel().removeRow(var4);
               return;
            }

            this.setItemValue(var4, "goodsid", var5);
            this.setItemValue(var4, "opcode", var2.getItemValue(var10, "opcode"));
            var6 = var2.getItemValue(var10, "leastsaleqty");
            var7 = var2.getItemValue(var10, "limitedsaleflag");
            this.d = var2.getItemValue(var10, "opcode");
            this.setItemValue(var4, "goodsno", var2.getItemValue(var10, "goodsno"));
            this.setItemValue(var4, "goodsname", var2.getItemValue(var10, "goodsname"));
            this.setItemValue(var4, "currencyname", var2.getItemValue(var10, "currencyname"));
            this.setItemValue(var4, "goodstype", var2.getItemValue(var10, "goodstype"));
            this.setItemValue(var4, "goodsunit", var2.getItemValue(var10, "goodsunit"));
            this.setItemValue(var4, "goodsuseunit", var2.getItemValue(var10, "goodsunit"));
            this.setItemValue(var4, "prodara", var2.getItemValue(var10, "prodara"));
            this.setItemValue(var4, "factoryname", var2.getItemValue(var10, "factoryname"));
            this.setItemValue(var4, "factoryid", var2.getItemValue(var10, "factoryid"));
            this.setItemValue(var4, "goodsdtlid", var2.getItemValue(var10, "goodsdtlid"));
            this.setItemValue(var4, "packname", var2.getItemValue(var10, "packname"));
            this.setItemValue(var4, "packsize", var2.getItemValue(var10, "packsize"));
            this.setItemValue(var4, "goodsqty", var2.getItemValue(var10, "editgoodsqty"));
            this.setItemValue(var4, "usepacksize", "1");
            this.setItemValue(var4, "goodsuseqty", var2.getItemValue(var10, "editgoodsqty"));
            this.setItemValue(var4, "batchno", var2.getItemValue(var10, "batchno"));
            this.setItemValue(var4, "batchid", var2.getItemValue(var10, "batchid"));
            this.setItemValue(var4, "lotno", var2.getItemValue(var10, "lotno"));
            this.setItemValue(var4, "invaliddate", var2.getItemValue(var10, "invaliddate"));
            this.setItemValue(var4, "lotid", var2.getItemValue(var10, "lotid"));
            this.setItemValue(var4, "posno", var2.getItemValue(var10, "posno"));
            this.setItemValue(var4, "posid", var2.getItemValue(var10, "posid"));
            this.setItemValue(var4, "goodsstatus", var2.getItemValue(var10, "goodsstatus"));
            this.setItemValue(var4, "goodsstatusid", var2.getItemValue(var10, "goodsstatusid"));
            this.setItemValue(var4, "storageid", var2.getItemValue(var10, "storageid"));
            this.setItemValue(var4, "storagename", var2.getItemValue(var10, "storagename"));
            this.setItemValue(var4, "storageno", var2.getItemValue(var10, "storageno"));
            this.setItemValue(var4, "storageopcode", var2.getItemValue(var10, "storageopcode"));
            this.setItemValue(var4, "wholesaleprice", var2.getItemValue(var10, "wholesaleprice"));
            this.setItemValue(var4, "resaleprice", var2.getItemValue(var10, "resaleprice"));
            this.setItemValue(var4, "prodarea", var2.getItemValue(var10, "prodarea"));
            this.setItemValue(var4, "batchprice", var2.getItemValue(var10, "unitprice"));
            this.setItemValue(var4, "limitedsaleflag", var7);
            this.setItemValue(var4, "leastsaleqty", var6);
            this.setItemValue(var4, "ephedrine", var2.getItemValue(var10, "ephedrine"));
            this.setItemValue(var4, "modeltype", var2.getItemValue(var10, "modeltype"));
            this.on_itemvaluechange(var4, "goodsid", var2.getItemValue(var10, "goodsid"));
            this.tableChanged(var4);
         }
      }

      this.tableChanged();
   }

   public void hovcallback_cancel() {
   }

   protected int on_new(int var1) {
      String var2 = ((Bms_sales_mde)this.mdemodel).getEntryid();
      this.d = "";
      this.setItemValue(var1, "allowbackflag", "1");
      this.setItemValue(var1, "correctflag", "0");
      this.setItemValue(var1, "settleflag", "0");
      int var3 = this.mdemodel.getMasterModel().getRow();
      String var12 = this.mdemodel.getMasterModel().getItemValue(var3, "customid");
      String var4 = (String)this.e.get(var12);
      RemotesqlHelper var5 = null;
      String var6 = null;
      String var7 = null;
      String var8 = null;
      if (var4 == null) {
         DBTableModel var13 = null;
         var2 = "select v.priceid,v.priceopcode,v.pricename,v.reqprintquflag from pub_company_to_definfo_v v where v.companyid=" + var12 + " and (v.entryid is null or v.entryid=" + var2 + ") order by nvl(v.israte,0),nvl(v.entryid,-1) desc";
         var5 = new RemotesqlHelper();

         try {
            var13 = var5.doSelect(var2, 0, 1);
         } catch (Exception var10) {
            this.a.error("error", var10);
            this.errorMessage("错误", var10.getMessage());
         }

         if (var13 != null && var13.getRowCount() > 0) {
            String var15 = var13.getItemValue(0, "priceid");
            var6 = var13.getItemValue(0, "priceopcode");
            var7 = var13.getItemValue(0, "pricename");
            var8 = var13.getItemValue(0, "reqprintquflag");
            this.e.put(var12, "1");
            this.setItemValue(var1, "priceid", var15);
            this.setItemValue(var1, "priceopcode", var6);
            this.setItemValue(var1, "pricename", var7);
            this.setItemValue(var1, "reqprintquflag", var8);
            ArrayList var11;
            (var11 = new ArrayList()).add(var15);
            var11.add(var6);
            var11.add(var7);
            var11.add(var8);
            this.f.put(var12, var11);
         } else {
            var2 = "select nvl(reqprintquflag,0)reqprintquflag from pub_customer where customid=" + var12;

            try {
               if ((var13 = var5.doSelect(var2, 0, 1)) != null && var13.getRowCount() > 0) {
                  var8 = var13.getItemValue(0, "reqprintquflag");
                  this.setItemValue(var1, "reqprintquflag", var8);
               }
            } catch (Exception var9) {
               var9.printStackTrace();
            }
         }
      } else {
         ArrayList var14 = (ArrayList)this.f.get(var12);
         this.setItemValue(var1, "priceid", (String)var14.get(0));
         this.setItemValue(var1, "priceopcode", (String)var14.get(1));
         this.setItemValue(var1, "pricename", (String)var14.get(2));
         this.setItemValue(var1, "reqprintquflag", (String)var14.get(3));
      }

      return super.on_new(var1);
   }

   protected int on_beforemodify(int var1) {
      if (!this.getItemValue(var1, "correctflag").equals("0")) {
         return -1;
      } else {
         this.setFocus("opcode");
         return super.on_beforemodify(var1);
      }
   }

   protected int on_beforedel(int var1) {
      return !this.getItemValue(var1, "correctflag").equals("0") ? -1 : super.on_beforedel(var1);
   }

   public void on_doubleclick(final int var1, final int var2) {
      this.setFocus("opcode");
      super.on_doubleclick(var1, var2);
      var2 = this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow());
      SwingUtilities.invokeLater(new Runnable() {
         public final void run() {
            String var1x = Bms_sales_detail.this.getItemValue(var1, "goodsid");
            Bms_sales_detail.super.on_itemvaluechange(var1, "goodsid", var1x);
            Bms_sales_detail.this.mdemodel.getMasterModel().setdbStatus(Bms_sales_detail.this.mdemodel.getMasterModel().getRow(), var2);
         }
      });
   }

   protected String getEditablecolumns(int var1) {
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var3 = this.mdemodel.getMasterModel().getItemValue(var2, "usestatus");
      String var6 = this.mdemodel.getMasterModel().getItemValue(var2, "approveflag");
      String var4 = this.getItemValue(var1, "priceid");
      String var5 = this.getItemValue(var1, "modifyflag");
      if ("2".equals(var3) && "0".equals(var6) && !"".equals(var4) && var1 >= 0 && var1 < this.getRowCount()) {
         if (var5 != null && var5.trim().length() > 0 && "1".equals(var5)) {
            this.getDBColumnDisplayInfo("unitprice").setReadonly(false);
            return "opcode,goodsuseunit,goodsuseqty,priceopcode,unitprice,discount,allowbackflag,dtlmemo,reqprintquflag";
         } else {
            return var5 != null && !"".equals(var5.trim()) ? "opcode,goodsuseunit,goodsuseqty,priceopcode,allowbackflag,dtlmemo,reqprintquflag" : "opcode,goodsuseunit,goodsuseqty,priceopcode,unitprice,discount,allowbackflag,dtlmemo,reqprintquflag";
         }
      } else {
         return super.getEditablecolumns(var1);
      }
   }

   public int doSave() {
      return super.doSave();
   }

   public int on_beforesave() {
      String var1 = ClientUserManager.getCurrentUser().getEntryid();
      boolean var2 = false;
      HashMap var3 = new HashMap();
      HashMap var4 = new HashMap();

      int var5;
      CSteModel var7;
      String var8;
      for(var5 = 0; var5 < this.getRowCount(); ++var5) {
         this.getDBtableModel().getRecordThunk(var5).setSaveresult(0, "");
         if (this.getdbStatus(var5) != 0 && this.on_checkrow11(var5, this.dbmodel) != 0) {
            return -1;
         }

         var7 = this.mdemodel.getMasterModel();
         if (var5 < 0 && var7.getdbStatus(var7.getRow()) == 3) {
            return 0;
         }

         if (this.getdbStatus(var5) != 3) {
            this.setItemValue(var5, "olderpqty", this.getItemValue(var5, "goodsqty"));
         }

         var8 = this.getItemValue(var5, "goodsid");
         if (var4.containsKey(var8)) {
            ((HashSet)var4.get(var8)).add(this.getItemValue(var5, "lotno"));
         } else {
            HashSet var9;
            (var9 = new HashSet()).add(this.getItemValue(var5, "lotno"));
            var4.put(var8, var9);
         }

         if (this.getdbStatus(var5) != 3) {
            var2 = true;
            if (!var3.containsKey(var8)) {
               var3.put(var8, Double.parseDouble(this.getItemValue(var5, "goodsqty")));
            } else if (var3.containsKey(var8)) {
               Double var22 = (Double)var3.get(var8) + Double.parseDouble(this.getItemValue(var5, "goodsqty"));
               var3.remove(var8);
               var3.put(var8, var22);
            }
         }
      }

      String var6;
      String var12;
      String var19;
      if (var2) {
         var19 = "";
         var6 = null;
         var7 = null;
         Iterator var23 = var3.keySet().iterator();

         while(var23.hasNext()) {
            var8 = (String)var23.next();
            var12 = "select leastsaleqty from pub_entry_goods t  where t.entryid = " + var1 + " and t.goodsid = " + var8;
            RemotesqlHelper var15 = new RemotesqlHelper();

            try {
               DBTableModel var16;
               if ((var16 = var15.doSelect(var12, 0, 2147483646)).getRowCount() > 0 && (var6 = var16.getItemValue(0, "leastsaleqty")).trim().length() > 0 && DecimalHelper.comparaDecimal(String.valueOf(DecimalHelper.toDec(String.valueOf(var3.get(var8))).remainder(DecimalHelper.toDec(var6))), "0") > 0) {
                  var19 = var19 + "货品ID为" + var8 + "的货品没有按照【货品基础数据管理】中设置的最小销售数量（" + var6 + "）的整数倍进行销售;";
               }
            } catch (Exception var11) {
               var11.printStackTrace();
            }
         }

         if (var19.trim().length() > 0) {
            var19 = var19 + "是否继续开单？";
            if (JOptionPane.showConfirmDialog(this.frame, var19, "提示", 0) == 1) {
               return -1;
            }
         }
      }

      if (this.getRowCount() > 1) {
         var5 = this.mdemodel.getMasterModel().getRow();
         String var20 = c(var6 = this.mdemodel.getMasterModel().getItemValue(var5, "customid"));

         for(int var21 = 0; var21 < this.getRowCount(); ++var21) {
            if (this.getdbStatus(var21) != 3) {
               String var24 = this.getItemValue(var21, "goodsid");
               var12 = this.getItemValue(var21, "lotid");
               String var17;
               if ((var17 = a(var1, var24)) != null && var17.trim().length() > 0 && !"0".equals(var17)) {
                  String var14;
                  int var18;
                  if ("1".equals(var17)) {
                     for(var18 = var21 + 1; var18 < this.getRowCount(); ++var18) {
                        if (this.getdbStatus(var18) != 3) {
                           var14 = this.getItemValue(var18, "goodsid");
                           var19 = this.getItemValue(var18, "lotid");
                           if (var24.equals(var14) && !var12.equals(var19)) {
                              this.infoMessage("提示", "货品ID[" + var24 + "]不允许混批，只能为一个批号");
                              return -1;
                           }
                        }
                     }
                  } else if ("2".equals(var17) && (var20 == null || !"0".equals(var20.trim()))) {
                     if (var20 != null && "1".equals(var20.trim())) {
                        for(var18 = var21 + 1; var18 < this.getRowCount(); ++var18) {
                           if (this.getdbStatus(var18) != 3) {
                              var14 = this.getItemValue(var18, "goodsid");
                              var19 = this.getItemValue(var18, "lotid");
                              if (var24.equals(var14) && !var12.equals(var19) && JOptionPane.showConfirmDialog(this.frame, "客户ID[" + var6 + "]允许混批一个，货品ID[" + var24 + "]只能为一个批号,是否继续开单？", "提示", 0) == 1) {
                                 return -1;
                              }
                           }
                        }
                     } else if (var20 != null && "2".equals(var20.trim())) {
                        var18 = 1;

                        for(int var13 = 0; var13 < this.getRowCount(); ++var13) {
                           if (this.getdbStatus(var13) != 3) {
                              var19 = this.getItemValue(var13, "goodsid");
                              String var10 = this.getItemValue(var13, "lotid");
                              if (var24.equals(var19) && !var12.equals(var10)) {
                                 ++var18;
                              }
                           }
                        }

                        if (var18 > 2 && JOptionPane.showConfirmDialog(this.frame, "客户ID[" + var6 + "]允许混批两个，货品ID[" + var24 + "]不能为多于两个批号,是否继续开单？", "提示", 0) == 1) {
                           return -1;
                        }
                     }
                  }
               }
            }
         }
      }

      return super.on_beforesave();
   }

   private static String a(String var0, String var1) {
      String var2 = null;
      String var3 = "select a.nomixsale from pub_entry_goods a where a.goodsid=%s and a.entryid=%s";
      RemotesqlHelper var4 = new RemotesqlHelper();

      try {
         DBTableModel var6;
         if ((var6 = var4.doSelect(String.format(var3, var1, var0), 0, 1)) != null && var6.getRowCount() > 0) {
            var2 = var6.getItemValue(0, "nomixsale");
         }
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      return var2;
   }

   private static String c(String var0) {
      String var1 = "";
      var0 = "select nomixsale from pub_company_to_definfo_v where companyid = " + var0 + " and entryid = " + ClientUserManager.getCurrentUser().getEntryid();
      RemotesqlHelper var2 = new RemotesqlHelper();

      try {
         DBTableModel var4;
         if ((var4 = var2.doSelect(var0, 0, 1)) != null && var4.getRowCount() > 0) {
            var1 = var4.getItemValue(0, "nomixsale");
         }
      } catch (Exception var3) {
         var3.printStackTrace();
      }

      return var1;
   }

   private boolean d(String var1) {
      CompanyOnClient var2 = null;
      String var3 = ((Bms_sales_mde)this.mdemodel).getEntryid();
      String var4 = null;

      try {
         RemotesqlHelper var5 = new RemotesqlHelper();
         String var6 = "select a.entrycompanyid\n  from pub_entry a\n where a.entryid = " + var3;
         DBTableModel var8;
         if ((var8 = var5.doSelect(var6, 0, 1)) != null && var8.getRowCount() > 0) {
            var4 = var8.getItemValue(0, "entrycompanyid");
         }

         var2 = new CompanyOnClient(var4);
      } catch (Exception var7) {
         var7.printStackTrace();
         this.errorMessage("错误", "检查独立单元自身证照经营范围发生异常，原因为：" + var7.getMessage());
      }

      return var2.sentLimitCheck("3", var3, new Goods(var1));
   }

   private static String a(String var0, DBTableModel var1, int var2) {
      String var3 = "";
      String var4 = null;
      String var6 = "";
      String var7 = var1.getItemValue(var2, "factoryid");
      String var8 = var1.getItemValue(var2, "goodsid");
      var4 = "select t.value\n  from Sys_npbusi_config_v t\n where t.keyword = 'managesqLetter'\n   and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid();
      RemotesqlHelper var5 = new RemotesqlHelper();

      DBTableModel var13;
      try {
         if ((var13 = var5.doSelect(var4, 0, 1)) != null && var13.getRowCount() > 0) {
            var6 = var13.getItemValue(0, "value");
         }
      } catch (Exception var10) {
         var10.printStackTrace();
      }

      if ("1".equals(var6)) {
         if (var7 != null && !"".equals(var7)) {
            var4 = "select *\n  from Factory_author_doc t\n where t.factoryid =" + var1.getItemValue(var2, "factoryid") + "   and t.entryid = " + ClientUserManager.getCurrentUser().getEntryid() + "   and t.Usestatus =1 and salestype =1 and Sqstartdate <=trunc(sysdate) and  trunc(Sqenddate) >= sysdate ";
            var5 = new RemotesqlHelper();

            try {
               if ((var13 = var5.doSelect(var4, 0, 1)) != null && var13.getRowCount() > 0) {
                  String var9 = var13.getItemValue(0, "coltype");
                  String var12 = var13.getItemValue(0, "authdocid");
                  var4 = "select * from  Factory_author_customer_dtl where customerid=" + var0 + " and authdocid =" + var12;
                  if ((var13 = (new RemotesqlHelper()).doSelect(var4, 0, 1)) != null && var13.getRowCount() > 0) {
                     if ("1".equals(var9)) {
                        var4 = "select * from  Factory_author_goods_dtl where Colvalueid=" + var8 + " and authdocid =" + var12;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var4, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var3 = "该货品ID：" + var8 + "没有授权给该客户，不能销售此货品";
                        }
                     } else if ("2".equals(var9)) {
                        var4 = "select * from  Factory_author_goods_dtl where authmxid= (select varietyid from pub_goods_v where goodsid = " + var8 + ") and authdocid =" + var12;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var4, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var3 = "该货品ID：" + var8 + "没有授权给该客户，不能销售此货品";
                        }
                     } else if ("3".equals(var9)) {
                        var4 = "select * from  Factory_author_goods_dtl where authmxid= (select varietydescid from pub_goods_v where goodsid = " + var8 + ") and authdocid =" + var12;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var4, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var3 = "该货品ID：" + var8 + "没有授权给该客户，不能销售此货品";
                        }
                     }

                     if ("4".equals(var9)) {
                        var4 = "select * from  Factory_author_goods_dtl where authmxid= (select vardesclassid from pub_goods_v where goodsid = " + var8 + ") and authdocid =" + var12;
                        if ((var13 = (new RemotesqlHelper()).doSelect(var4, 0, 1)) == null || var13.getRowCount() <= 0) {
                           var3 = "该货品ID：" + var8 + "没有授权给该客户，不能销售此货品";
                        }
                     }
                  } else {
                     var3 = "该货品生产厂家ID：" + var7 + "没有授权给该客户，不能销售此货品";
                  }
               } else {
                  var3 = "该生产厂家在该独立单元下没有有效的授权书，不能销售此货品";
               }
            } catch (Exception var11) {
               var11.printStackTrace();
            }
         } else {
            var3 = "没有取到该货品的生产厂家ID";
         }
      }

      return var3;
   }
}
